﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Backend
{
	/**
	 * Creates the structures of the benchmark backend: indexes,
	 * id pools, and large sets.
	 */
	[Immutable]
	public abstract class BackendFactory {

		public static BackendFactory instance = null;
		
		public static void SetInstance(BackendFactory newInstance) {
			if(instance != null) 
				throw new RuntimeError("BackendFactory already instantiated");
			instance = newInstance;
		}
		
		public abstract LargeSet CreateLargeSet();
		public abstract Index CreateIndex/*<K extends IndexKey, V>*/() /*where K: IndexKey*/;
		public abstract IdPool CreateIdPool(int maxNumberOfIds);
	}

}
