﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Backend
{
	/**
	 * Implements a pool of ids of various objects of the data structure.
	 * Necessary to ensure that no two objects of the same type and with
	 * the same id are created by different threads, and that the data
	 * structure does not grow beyond the limits defined in the Parameters
	 * class.
	 */
	[Atomic]
	public interface IdPool {

		[Update]
		int GetId();

		[Update]
		void PutUnusedId(int id);
	}
}
