﻿using System;
 
 
using System.Text;
using System.IO;

namespace STMBench7.Compatability
{
    /**
     *Loops through pseudorandom values from a file for the sake of having
     *the Java and C# versions of the benchmark on the same terms.
     */
    public class CannedRandom
    {
        private static double[] cannedValues = new double[4096];

        static CannedRandom()
        {
            
            StreamReader r = new StreamReader(new FileStream("cannedRandomValues", FileMode.Open));
            for (int i = 0; i < 4096; i++)
                cannedValues[i] = double.Parse(r.ReadLine());
            r.Close();
        }

        private int pos = 0;

        public CannedRandom(int ignore){}
        public CannedRandom(){}

        public int NextInt()
        {
            return NextInt(2147483647); //2^32-1
        }

        public int NextInt(int max)
        {
            return ((int)(NextDouble() * max));
        }

        public double NextDouble()
        {
            pos = (pos+1) % 4096;
            return cannedValues[pos];
        }
    }
}
