﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{
    /**
 * Part of the main benchmark data structure. For a default
 * implementation, see stmbench7.impl.core.BaseAssemblyImpl.
 */
    [Atomic]
    public interface BaseAssembly : Assembly
    {
        [Update]
        void AddComponent(CompositePart component);

        [Update]
        bool RemoveComponent(CompositePart component);

        [ReadOnly]
        ImmutableCollection/*<CompositePart>*/ GetComponents();
    }
}
