﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{
    /**
 * Part of the main benchmark data structure. For a default
 * implementation, see stmbench7.impl.core.ComplexAssemblyImpl.
 */
    [Atomic]
    public interface ComplexAssembly : Assembly
    {
        [Update]
        bool AddSubAssembly(Assembly assembly);

        [Update]
        bool RemoveSubAssembly(Assembly assembly);

        [ReadOnly]
        ImmutableCollection/*<Assembly>*/ GetSubAssemblies();

        [ReadOnly]
        short GetLevel();
    }
}
