﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{
    /**
 * Part of the main benchmark data structure. For a default
 * implementation, see stmbench7.impl.core.CompositePartImpl.
 */
    [Atomic]
    public interface CompositePart : DesignObj
    {
        [Update]
        void AddAssembly(BaseAssembly assembly);

        [Update]
        bool AddPart(AtomicPart part);

        [Update]
        void SetRootPart(AtomicPart part);

	    [ReadOnly]
	    AtomicPart GetRootPart();

	    [ReadOnly]
	    Document GetDocumentation();

	    [ReadOnly]
	    LargeSet/*<AtomicPart>*/ GetParts();

	    [Update]
	    void RemoveAssembly(BaseAssembly assembly);

	    [ReadOnly]
	    ImmutableCollection/*<BaseAssembly>*/ GetUsedIn();

	    [Update]
	    void ClearPointers();
    }
}
