﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Core
{

    /**
     * Part of the main benchmark data structure. For a default
     * implementation, see stmbench7.impl.core.DocumentImpl.
     */
    [Atomic]
    public interface Document
    {
        
	[Update]
	void SetPart(CompositePart part);

	[ReadOnly]
	CompositePart GetCompositePart();

	[ReadOnly]
	int GetDocumentId();

	[ReadOnly]
	String GetTitle();

	[ReadOnly]
	void NullOperation();

	[ReadOnly]
	int SearchText(char symbol);

	[Update]
	int ReplaceText(String from, String to);

	[ReadOnly]
	bool TextBeginsWith(String prefix);

	[ReadOnly]
	String GetText();
    }
}
