﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Backend;

namespace STMBench7.Core
{
	/**
	 * Used to create a manual element that conforms to the
	 * benchmark specification.
	 */
	[Immutable]
	public class ManualBuilder : DesignObjBuilder {

		private readonly IdPool idPool;
		
		public ManualBuilder() {
			idPool = BackendFactory.instance.CreateIdPool(Parameters.NumModules);
		}

        public virtual Manual CreateManual(int moduleId)
        {
			int manualId = idPool.GetId();
			String title = "Manual for module #" + moduleId;
			String text = CreateText(Parameters.ManualSize, "I am the manual for module #" + moduleId + "\n");
			
			return designObjFactory.CreateManual(manualId, title, text);
		}
	}

}
