﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Core
{
    /**
 * Interface of a single operation (query, traversal 
 * or structural modification) of the STMBench7 benchmark.
 * Each operation is instantiated separately by each
 * thread, so the fields in a class implementing Operation
 * can be considered thread-local.
 */
    [ThreadLocal]
    public interface Operation
    {
        [Transactional]
        int PerformOperation();
	
	    [ReadOnly]
	    OperationId GetOperationId();    
    }
}
