﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;

namespace STMBench7.Core
{

/**
 * STMBench7 specific error. Indicates a serious problem, i.e., a violation of
 * the data structure invariants, which causes the benchmark to terminate.
 */
[Immutable]
[ThreadLocal]
public class RuntimeError : Exception {

	public RuntimeError() {
	}

    public RuntimeError(String message)
        : base(message)
    {
		
	}

    public RuntimeError(Exception cause)
        : base(cause.ToString(),cause)
    {
		
	}

	public RuntimeError(String message, Exception cause) : base(message, cause) {
		
	}

}

}
