﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Correctness.Invariants
{
	/**
	 * Test of invariants of a base assembly.
	 */
	[Immutable]
	[ThreadLocal]
	public class BaseAssemblyTest : InvariantTest {

		public static void CheckInvariants(BaseAssembly assembly, bool initial,
				ComplexAssembly parentAssembly, Module module, TraversedObjects traversedObjects) {

			traversedObjects.baseAssemblies.Add(assembly);
			
			AssemblyTest.CheckInvariants(assembly, initial, Parameters.MaxBaseAssemblies, parentAssembly, module);
			
			foreach(CompositePart component in assembly.GetComponents())
				CompositePartTest.CheckInvariants(component, initial, assembly, traversedObjects);
		}
	}

}
