﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Correctness.Invariants
{
	/**
	 * Test of invariants of a connection.
	 */
	[Immutable]
	[ThreadLocal]
	public class ConnectionTest : InvariantTest {

		public static void CheckInvariants(Connection connection, AtomicPart from) {

			if(! DesignObjTest.CheckType(connection.GetType()))
				ReportError(connection, 0, "type", "type #...", connection.GetType());
			
			int length = connection.GetLength();
			if(length < 1 || length > Parameters.XYRange)
				ReportError(connection, 0, "length", 1, Parameters.XYRange, length);
			
			if(connection.GetSource() != from)
				ReportError(connection, 0, "invalid source (from) reference");
		}
	}

}
