﻿using System;
 
 
using System.Text;

using STMBench7.Annotations;
using STMBench7.Core;
using STMBench7.Compatability;

namespace STMBench7.Correctness.Invariants
{
	/**
	 * Stores the sets of objects traversed during an invariants
	 * check performed by the CheckInvariantsOperation class.
	 */
	[Immutable]
	[ThreadLocal]
	public class TraversedObjects {

		public readonly HashtableSet/*<ComplexAssembly>*/ complexAssemblies;
        public readonly HashtableSet/*<BaseAssembly>*/ baseAssemblies;
        public readonly HashtableSet/*<CompositePart>*/ components;
        public readonly HashtableSet/*<Document>*/ documents;
        public readonly HashtableSet/*<AtomicPart>*/ atomicParts;
		
		public TraversedObjects() {
            complexAssemblies = new HashtableSet/*<ComplexAssembly>*/();
            baseAssemblies = new HashtableSet/*<BaseAssembly>*/();
            components = new HashtableSet/*<CompositePart>*/();
            documents = new HashtableSet/*<Document>*/();
            atomicParts = new HashtableSet/*<AtomicPart>*/();
		}
	}

}
