﻿using System;
 
 
using System.Text;
using STMBench7.Backend;
using STMBench7.Compatability;
using System.Collections;

namespace STMBench7.Impl.Backend
{
	/**
	 * Implements a read-only collection of objects.
	 */
	public class ImmutableCollectionImpl : ImmutableCollection {

		private readonly LinkedList2 snapshot;

        //Don't [BartokSTMExtensions.NoLogTrans] 
		//Still need to log the reads.  See LinkedList2.
        public ImmutableCollectionImpl(IEnumerable elements)
        {
            snapshot = new LinkedList2(elements);
		}


		public int Size() {
			return snapshot.Count;
		}
		
		public bool Contains(Object element) {
			return snapshot.Contains(element);
		}
        
        public IEnumerator GetEnumerator()
        {
            return snapshot.GetEnumerator();
        }
    }

}
