﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using System.Collections;
using STMBench7.Compatability;

namespace STMBench7.Impl.Backend
{
	/**
	 * A simple implementation of a small-size set
	 * (used by Assembly and AtomicPart objects).
	 */
	[ContainedInAtomic]
	public class SmallSetImpl : IEnumerable {

		//private ArrayList elements;
        private LinkedList2 elements;


        [BartokSTMExtensions.NoLogTrans] //allocation that does not escape "this"
		public SmallSetImpl() {
            elements = new LinkedList2();
		}

        //Don't [BartokSTMExtensions.NoLogTrans] 
        //Still need to log the reads.  See LinkedList2.
        public SmallSetImpl(SmallSetImpl source)
        {
            elements = new LinkedList2(source.elements);
		}
		
		public bool Add(Object element) {
			if(elements.Contains(element)) return false;
			
			elements.Add(element);
			return true;
		}
		
		public bool Remove(Object element) {
            if (!elements.Contains(element)) return false;
			elements.Remove(element);
            return true;
		}
		
		public bool Contains(Object element) {
			return elements.Contains(element);
		}
		
		public int Size() {
			return elements.Count;
		}

        IEnumerator IEnumerable.GetEnumerator()
        {
            return elements.GetEnumerator();
        }

    }
}
