﻿using System;
 
 
using System.Text;

using STMBench7.Core;

namespace STMBench7.Impl.Core
{

/**
 * STMBench7 benchmark Assembly (see the specification).
 * Default implementation.
 */
public abstract class AssemblyImpl : DesignObjImpl , Assembly {

    protected ComplexAssembly superAssembly;
    protected Module module;

    public AssemblyImpl(int id, String type, int buildDate, Module module, ComplexAssembly superAssembly)
        : base(id, type, buildDate)
    {
       	this.module = module;
    	this.superAssembly = superAssembly;
    }

    public AssemblyImpl(AssemblyImpl source)
        : base(source)
    {
    	this.superAssembly = source.superAssembly;
    	this.module = source.module;
    }

    public virtual ComplexAssembly GetSuperAssembly()
    {
    	return superAssembly;
    }

    public virtual Module GetModule()
    {
    	return module;
    }

    public virtual void ClearPointers()
    {
    	superAssembly = null;
    	module = null;
    }
}

}
