﻿using System;
 
 
using System.Text;

using STMBench7.Core;

namespace STMBench7.Impl.Core
{
	/**
	 * STMBench7 benchmark Design Object (see the specification). Default
	 * implementation.
	 */
	public class DesignObjImpl : DesignObj {

        private int hash = new Object().GetHashCode();

        public override int GetHashCode()
        {
            return hash;
        }


		protected readonly int id;
		protected String type;
		protected int buildDate;

		public DesignObjImpl(int id, String type, int buildDate) {
			this.id = id;
			this.type = type;
			this.buildDate = buildDate;
		}

		public DesignObjImpl(DesignObjImpl source) {
			this.id = source.id;
			this.type = source.type;
			this.buildDate = source.buildDate;
		}

		public virtual int GetId() {
			return id;
		}

		public virtual int GetBuildDate() {
			return buildDate;
		}

		public virtual void UpdateBuildDate() {
			if (buildDate % 2 == 0)
				buildDate--;
			else
				buildDate++;
		}

		public virtual void NullOperation() {
		}

		public virtual String GetType() {
			return type;
		}
	}

}
