﻿using System;
 
 
using System.Text;
using STMBench7.Core;

namespace STMBench7.Impl
{

/**
 * Default implementation of an OperationExecutor.
 * Does not provide any thread-safety.
 */
    public class DefaultOperationExecutor : OperationExecutor {

	    private readonly Operation op;
	    private int lastTimestamp = 0;
    	
	    public DefaultOperationExecutor(Operation op) {
		    this.op = op;
	    }

        public virtual int Execute()
        {
		    return op.PerformOperation();
	    }

        public virtual int GetLastOperationTimestamp()
        {
		    return lastTimestamp++;
	    }	
    }

}
