﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;

namespace STMBench7.Impl
{
	/**
	 * Default implementation of an OperationExecutorFactory.
	 * It creates an OperationExecutor that does not provide
	 * any synchronization between threads.
	 */
	[Immutable]
	public class DefaultOperationExecutorFactory : OperationExecutorFactory {

        public override OperationExecutor CreateOperationExecutor(Operation op)
        {
			return new DefaultOperationExecutor(op);
		}
	}

}
