﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Locking;
using STMBench7.Impl;

namespace STMBench7
{
	/**
	 * Parameters that describe the synchronization techniques
	 * compiled in the benchmark.
	 */
	[NonAtomic]
	[ThreadLocal]
	public class ImplParameters {

		public static readonly Type /*Class<? extends SynchMethodInitializer>*/
			noSynchronizationInitializerClass = typeof(NoSynchronizationInitializer),
			coarseGrainedLockingInitializerClass = typeof(CGLockingInitializer),
			mediumGrainedLockingInitializerClass = typeof(MGLockingInitializer),
			fineGrainedLockingInitializerClass = null; // not implemented yet
		
		/**
		 * If non-null, the STM initializer does not have to be specified
		 * each time the benchmark is run with the "-g stm" command-line
		 * parameter.
		 */
		public static readonly Type /*Class<? extends SynchMethodInitializer>*/
			defaultSTMInitializerClass = typeof(STMInitializer);
	}

}
