﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;

namespace STMBench7
{
	/**
	 * Types of STMBench7 operations. The "RO" suffix means "read-only".
	 */
	[NonAtomic]
	public /*enum*/ class OperationType {
		
        public static readonly OperationType
        TRAVERSAL = new OperationType("TRAVERSAL"),
        TRAVERSAL_RO = new OperationType("TRAVERSAL_RO"),
        SHORT_TRAVERSAL = new OperationType("SHORT_TRAVERSAL"),
        SHORT_TRAVERSAL_RO = new OperationType("SHORT_TRAVERSAL_RO"),
        OPERATION = new OperationType("OPERATION"),
        OPERATION_RO = new OperationType("OPERATION_RO"),
        STRUCTURAL_MODIFICATION = new OperationType("STRUCTURAL_MODIFICATION");

        private static OperationType[] values_ = new OperationType[] { 
            TRAVERSAL, TRAVERSAL_RO, SHORT_TRAVERSAL, SHORT_TRAVERSAL_RO, OPERATION, OPERATION_RO, STRUCTURAL_MODIFICATION};
		
        public static OperationType[] values()
        {
                return values_;
        }
        private String str;
        private OperationType(String str)
        {
            this.str = str;
        }
        public override string ToString()
        {
            return str;
        }

		/**
		 * Some helper fields to make life easier.
		 */
		public int count = 0;
		public double probability = 0;
		public int successfulOperations = 0, failedOperations = 0, maxttc = 0;
	}

}
