﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Compatability;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Operation OP10 (see the specification).
	 * Simple update, range query on index.
	 */
	public class Operation10 : Query2 {

	    public Operation10(Setup oo7setup) : base(oo7setup, 1) {
	    	
	    }
	    
		[Transactional] [Update]
		public override int PerformOperation() {
            return base.PerformOperation();
		}
	    
        protected override void PerformOperationInAtomicPart(AtomicPart atomicPart)
        {
			atomicPart.SwapXY();
		}
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP10;
	    }
	}

}
