﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Backend;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Operation OP15 (see the specification).
	 * Simple update, search and update on index.
	 */
	public class Operation15 : Query1 {

		protected Index/*<IntIndexKey,LargeSet<AtomicPart>>*/ partBuildDateIndex;

        public Operation15(Setup oo7setup)
            : base(oo7setup)
        {
			this.partBuildDateIndex = oo7setup.GetAtomicPartBuildDateIndex();
		}
		
		[Transactional] [Update]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}
	    
        protected override void PerformOperationInAtomicPart(AtomicPart atomicPart)
        {
			RemoveAtomicPartFromBuildDateIndex(partBuildDateIndex, atomicPart);
			atomicPart.UpdateBuildDate();
			AddAtomicPartToBuildDateIndex(partBuildDateIndex, atomicPart);
		}
	   
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP15;
	    }
	}

}
