﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Backend;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Query Q1 / Operation OP1 (see the specification).
	 * Read-only, search on index.
	 */
	public class Query1 : BaseOperation {

		Index/*<IntIndexKey,AtomicPart>*/ partIdIndex;

		public Query1(Setup oo7setup) {
			this.partIdIndex = oo7setup.GetAtomicPartIdIndex();
		}

        [BartokSTMExtensions.NoLog]
		[Transactional] [ReadOnly]
        public override int PerformOperation()
        {
			int count = 0;
			
			for(int i = 0; i < 10; i++) {
				int partId = ThreadRandom.NextInt(Parameters.MaxAtomicParts) + 1;
                AtomicPart part = (AtomicPart)partIdIndex.Get(new IntIndexKey(partId));

				if(part == null) continue;

				PerformOperationInAtomicPart(part);
				count++;
			}

			return count;
		}

        protected virtual void PerformOperationInAtomicPart(AtomicPart atomicPart)
        {
			atomicPart.NullOperation();
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP1;
	    }
	}

}
