﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Backend;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Query Q4 / Short traversal ST4 (see the specification).
	 * Read-only, search on index, short.
	 */
	public class Query4 : BaseOperation {

	    Index/*<StringIndexKey,Document>*/ documentTitleIndex;

	    public Query4(Setup oo7setup) {
	    	this.documentTitleIndex = oo7setup.GetDocumentTitleIndex();
	    }

		[Transactional] [ReadOnly]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
	    	int result = 0;

	    	for(int i = 0; i < 100; i++) {
	    		int partId = ThreadRandom.NextInt(Parameters.MaxCompParts) + 1;
	    		StringIndexKey docTitle = new StringIndexKey("Composite Part #" + partId);

	    		Document document = (Document)documentTitleIndex.Get(docTitle);
	    		if(document == null) continue;

	    		foreach(BaseAssembly assembly in document.GetCompositePart().GetUsedIn()) {
	    			assembly.NullOperation();
	    			result++;
	    		}
	    	}

	    	return result;
	    }
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.ST4;
	    }
	}


}
