﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Annotations;
using STMBench7.Backend;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Query Q7 (see the specification).
	 * Read-only, iterate on index, long.
	 */
	public class Query7 : BaseOperation {

	    protected Index/*<IntIndexKey,AtomicPart>*/ partIdIndex;

	    public Query7(Setup oo7setup) {
	    	this.partIdIndex = oo7setup.GetAtomicPartIdIndex();
	    }

	    [Transactional] [ReadOnly]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
	    	int result = 0;
	    	foreach(AtomicPart part in partIdIndex) {
	    		part.NullOperation();
	    		result++;
	    	}
	    	return result;
	    }
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.Q7;
	    }
	}

}
