﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Short traversal ST6 (see the specification).
	 * Simple update, short.
	 */
    public class ShortTraversal6 : ShortTraversal1
    {

        public ShortTraversal6(Setup oo7setup)
            : base(oo7setup)
        {
		}

		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}

	    [BartokSTMExtensions.NoLog]
        protected override int Traverse(AtomicPart atomicPart)
        {
			atomicPart.SwapXY();
			return base.Traverse(atomicPart);
		}
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.ST6;
	    }
	}

}
