﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Short traversal ST8 (see the specification).
	 * Indexed update, short.
	 */
	public class ShortTraversal8 : Traversal7 {

        public ShortTraversal8(Setup oo7setup)
            : base(oo7setup)
        {
		}
	    
		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}
	    	
        [BartokSTMExtensions.NoLog]
        protected override void PerformOperationOnAssembly(Assembly assembly)
        {
	    	assembly.UpdateBuildDate();
	    }
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.ST8;
	    }
	}

}
