﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;
using STMBench7.Compatability;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Structural modification operation SM1 (see the specification).
	 */
	public class StructuralModification1 : BaseOperation {

		protected CompositePartBuilder compositePartBuilder;
		
		public StructuralModification1(Setup oo7setup) {
			compositePartBuilder = oo7setup.GetCompositePartBuilder();
		}

		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
			compositePartBuilder.CreateAndRegisterCompositePart();
			return 0;
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.SM1;
	    }
	}
}
