﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Annotations;
using STMBench7.Core;
using STMBench7.Backend;

namespace STMBench7.Operations
{
	/**
	 * Structural modification SM7 (see the specification).
	 */
	public class StructuralModification7 : BaseOperation {

		protected AssemblyBuilder assemblyBuilder;
		protected Index/*<IntIndexKey,ComplexAssembly>*/ complexAssemblyIdIndex;
		protected Module module;
		
		public StructuralModification7(Setup oo7setup) {
			this.complexAssemblyIdIndex = oo7setup.GetComplexAssemblyIdIndex();
			this.module = oo7setup.GetModule();
			assemblyBuilder = oo7setup.GetAssemblyBuilder();
		}
		
		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            int superAssemblyId = ThreadRandom.NextInt(Parameters.MaxComplexAssemblies) + 1;
            ComplexAssembly superAssembly = (ComplexAssembly)complexAssemblyIdIndex.Get(new IntIndexKey(superAssemblyId));
            if(superAssembly == null) throw new OperationFailedException();

            assemblyBuilder.CreateAndRegisterAssembly(module, superAssembly);
            
            return 1;
		}

        public override OperationId GetOperationId()
        {
	    	return OperationId.SM7;
	    }
	}

}
