﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Annotations;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Traversal T2, variant (a) (see the specification).
	 * Simple update, long.
	 */
	public class Traversal2a : Traversal1 {

        public Traversal2a(Setup oo7setup) : base(oo7setup)
        {
	    }

		[Transactional] [Update]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}

        [BartokSTMExtensions.NoLog]
        protected override int PerformOperationInAtomicPart(AtomicPart part, HashtableSet/*<AtomicPart>*/ setOfVisitedPartIds)
        {
	    	if(setOfVisitedPartIds.Count==0) {
	    		part.SwapXY();
	    		return 1;
	    	}

	    	part.NullOperation();
	    	return 0;
	    }
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.T2a;
	    }
	}
}
