﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Traversal T4 (see the specification).
	 * Read-only, long.
	 */
	public class Traversal4 : Traversal1 {

        public Traversal4(Setup oo7setup)
            : base(oo7setup) {
	    }

        protected override int Traverse(CompositePart component)
        {
	    	Document documentation = component.GetDocumentation();
	    	return Traverse(documentation);
	    }

        protected virtual int Traverse(Document documentation)
        {
	    	return documentation.SearchText('I');
	    }

        protected override int Traverse(AtomicPart part, HashtableSet/*<AtomicPart>*/ setOfVisitedPartIds)
        {
            throw new RuntimeError("T4: traverse(AtomicPart, HashtableSet<AtomicPart>) called!");
	    }
        
        protected override int PerformOperationInAtomicPart(AtomicPart part, HashtableSet/*<AtomicPart>*/ setOfVisitedPartIds)
        {
	    	throw new RuntimeError("T4: performOperationInAtomicPart(..) called!");
	    }
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.T4;
	    }
	}

}
