﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Core;
using STMBench7.Annotations;

namespace STMBench7.Operations
{
	/**
	 * Traversal T5 (see the specification).
	 */
	public class Traversal5 : Traversal4 {

        public Traversal5(Setup oo7setup)
            : base(oo7setup)
        {
	    }

		[Transactional] [Update]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            return base.PerformOperation();
		}

        [BartokSTMExtensions.NoLog]
        protected override int Traverse(Document documentation)
        {
	    	int result;
	    	
	    	if(documentation.TextBeginsWith("I am"))
	    		result = documentation.ReplaceText("I am", "This is");
	    	else if(documentation.TextBeginsWith("This is"))
	    		result = documentation.ReplaceText("This is", "I am");
	    	else
	    		throw new RuntimeError("T5: illegal document text: " + documentation.GetText());
	    
	    	if(result == 0) throw new RuntimeError("T5: concurrent modification!");
	    	return result;
	    }
	    
        public override OperationId GetOperationId()
        {
	    	return OperationId.T5;
	    }
	}

}
