﻿using System;
 
 
using System.Text;
using STMBench7.Compatability;
using STMBench7.Core;

namespace STMBench7.Operations
{
	/**
	 * Traversal T6 (see the specification).
	 * Read-only, long.
	 */
	public class Traversal6 : Traversal1 {

		public Traversal6(Setup oo7setup) : base(oo7setup) {
		}

        [BartokSTMExtensions.NoLog]
        protected override int Traverse(CompositePart component)
        {
			AtomicPart rootPart = component.GetRootPart();
			return Traverse(rootPart, null);
		}

        [BartokSTMExtensions.NoLog]
        protected override int Traverse(AtomicPart part, HashtableSet/*<AtomicPart>*/ setOfVisitedPartIds)
        {
			return PerformOperationInAtomicPart(part, null);
		}
        [BartokSTMExtensions.NoLog]
        protected override int PerformOperationInAtomicPart(AtomicPart part, HashtableSet/*<AtomicPart>*/ setOfVisitedPartIds)
       {
			part.NullOperation();
			return 1;
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.T6;
	    }
	}

}
