﻿using System;
 
 
using System.Text;
using STMBench7.Core;
using STMBench7.Annotations;
using STMBench7.Compatability;

namespace STMBench7.Operations
{
	/**
	 * Traversal T8 / Operation OP4 (see the specification).
	 * Read-only.
	 */
	public class Traversal8 : BaseOperation {

		protected Module module;

		public Traversal8(Setup oo7setup) {
			this.module = oo7setup.GetModule();
		}

		[Transactional] [ReadOnly]
        [BartokSTMExtensions.NoLog]
        public override int PerformOperation()
        {
            Manual manual = module.GetManual();
			return Traverse(manual);
		}

        [BartokSTMExtensions.NoLog]
       protected virtual int Traverse(Manual manual)
        {
			return manual.CountOccurences('I');
		}
		
        public override OperationId GetOperationId()
        {
	    	return OperationId.OP4;
	    }
	}

}
