﻿using System;
 
 
using System.Text;
using STMBench7.Annotations;

namespace STMBench7
{

    /**
     * Application workload.
     */
    [Immutable]
    public /*enum*/ class WorkloadType
    {
        public static readonly WorkloadType
        READ_DOMINATED = new WorkloadType(90, "READ_DOMINATED"),
        READ_WRITE = new WorkloadType(60, "READ_WRITE"),
        WRITE_DOMINATED = new WorkloadType(10, "WRITE_DOMINATED"),
        STM_BIASED = new WorkloadType(0, "STM_BIASED");

        public readonly int readOnlyOperationsRatio;
        public readonly String name;

        private WorkloadType(int readOnlyOperationsRatio, String name)
        {
            this.readOnlyOperationsRatio = readOnlyOperationsRatio;
            this.name = name;
        }
        public override String ToString()
        {
            return name;
        }
    }
}
